//
//
//
#ifndef SWITCHED_FILTERS_H
#define SWITCHED_FILTERS_H

#include "mbuffer.h"

#define NUM_SIFO                        4             // Number of filters
#define HPF_SIFO_FPO                    4             // input->UseHPFilter
#define SIFO_FILTERS_ONLY               0
#define SIFO_USE_OFFSETS                1
#define NO_BEST_FILTER                  0
#define SQR_FILTER                      36

void readSIFOHeader();
int getblock2DFilt_quarter_pel(int ref_idx, StorablePicture **list, int x_pos, int y_pos,
                               int mvx, int mvy, int img_width, int img_height, 
                               int block[16][16], int size_x,int size_y);
int getblock2DFilt(int ref_idx, StorablePicture **list, int x_pos, int y_pos,
                   int mvx, int mvy, int img_width, int img_height, int block[16][16], int size_x,int size_y);



int getblockOneEighthFilt_quarter_pel(int ref_idx, StorablePicture **list, int x_pos, int y_pos,
                                      int mvx, int mvy, int img_width, int img_height, 
                                      int block[16][16], int size_x,int size_y);
int getblockH264HPFFilt_quarter_pel  (int ref_idx, StorablePicture **list, int x_pos, int y_pos,
                                      int mvx, int mvy, int img_width, int img_height, 
                                      int block[16][16], int size_x,int size_y);



#endif  // SWITCHED_FILTERS_H
