
/*!
************************************************************************
* \file vlc.h
*
* \brief
*    header for (CA)VLC coding functions
*
* \author
*    Karsten Suehring
*
************************************************************************
*/

#ifndef _VLC_H_
#define _VLC_H_

int se_v (char *tracestring, Bitstream *bitstream);
int ue_v (char *tracestring, Bitstream *bitstream);
int u_1 (char *tracestring, Bitstream *bitstream);
int u_v (int LenInBits, char *tracestring, Bitstream *bitstream);

// UVLC mapping
void linfo_ue(int len, int info, int *value1, int *dummy);
void linfo_se(int len, int info, int *value1, int *dummy);
int  readSyntaxElement_VLC (SyntaxElement *sym, Bitstream *currStream);
int  GetVLCSymbol (byte buffer[],int totbitoffset,int *info, int bytecount);
int readSyntaxElement_FLC(SyntaxElement *sym, Bitstream *currStream);
int GetBits (byte buffer[],int totbitoffset,int *info, int bytecount, 
             int numbits);
int more_rbsp_data (byte buffer[],int totbitoffset,int bytecount);

#endif

