
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>
#include "global.h"

#ifndef POSTFILTER_H
#define POSTFILTER_H


void postProcessing(Bitstream *bitstream, imgpel **imgY_rec, imgpel **imgY_org, int frNo, int qp, int img_height, int img_width, int BDI, int BDL);


int TerminateSliceForPF(Picture* pic,Bitstream *bitstream);

//
//  varBasedPostprocessing.c
//
double findBestFilterVarPred(Bitstream *bitstream, imgpel **imgY_rec, imgpel **imgY_org, imgpel **varImg, 
                             int frNo, int qp, int *filtNo_best, double **filterCoeffSym, int varIndTab[], 
                            int usePrevFiltBest[], int *prevFiltInd, int *forceCoeff0, int *codedFlag, 
                            int img_height, int img_width);




#endif // DEFINES_H

