#ifndef _QC_FILTER_H_
#define _QC_FILTER_H_

#ifdef ADAPTIVE_LOOP_FILTER
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>
#include "global.h"
#include "alf_filter_common.h"
//
//  varBasedPostprocessing.c
//

void init_qc_filter(int height,int width);
void delete_qc_filter();
void CalValImage( imgpel **ImgDec);
void FilteringFrameLuma_qc(imgpel **ImgOrg, imgpel **ImgDec, imgpel **ImgRest,int tap,alf_parameter_set_rbsp_t* temp_alfps);
void StoreInBlockMartix(unsigned int *****blk_corr,imgpel** ImgOrg, imgpel** ImgDec);
int fillInMartix_direct(alf_parameter_set_rbsp_t* temp_alfps,imgpel** ImgOrg, imgpel** ImgDec,int getfromImg,int tap);
int send_ALFLumaParam_qc(Bitstream * bitstream);
void saveBestBitstream();
void LoadBestBitstream();
void saveBitstream_fullframe();
void LoadBitstream_fullframe();
void printImgHeight();
int fillInMartixfromBlockMatrix(double *****blk_corr,double ***blk_pixAcc,alf_parameter_set_rbsp_t* temp_alfps,int getfromImg,imgpel** ImgOrg, imgpel** ImgDec);
void storeInBlockMartix(double *****blk_corr,double ***blk_pixAcc,imgpel** ImgOrg, imgpel** ImgDec);
int storeInBlockMartix_update(double *****blk_corr,double ***blk_pixAcc,alf_parameter_set_rbsp_t* temp_alfps,int prev_idx);
int fillInMartixfromBlockMatrix_update(double *****blk_corr,double ***blk_pixAcc,alf_parameter_set_rbsp_t* temp_alfps,int getfromImg);

void setCodedFilter();

void postProcessing(alf_parameter_set_rbsp_t* alfps,Bitstream *alfstream,imgpel** ImgOrg, imgpel** imgY_rec);
#endif
#endif

