#
#
#
$seqdir  		= "C:/00_YUV";

#
# Sequence name and sequence-dependent parameters


%seqsnum = (
#	      "01",	"CIF30_300_Foreman",
	      "01",	"WQVGA30_RaceHorses",
#	      "02",	"WQVGA50_Basketball",
#	      "03",	"WQVGA50_PartyScene",
#	      "04",	"WQVGA60_BQSquare",
#
#	      "05",	"WVGA30_RaceHorses",
#	      "06",	"WVGA50_Basketball",
#	      "07",	"WVGA50_PartyScene",
#	      "08",	"WVGA60_BQSquare",
#
#	      "09",	"1080p24_ParkScene",
#	      "10",	"1080p50_Basketball",
#	      "11",	"1080p50_Cactus",
#	      "12",	"1080p50_PartyScene",
#	      "13",	"1080p24_Kimono",
#	      "14",	"1080p60_BQSquare",
#
#	      "15",	"2560x1600_30_PeopleOnStreet",
#	      "16",	"2560x1600_30_Traffic",
#	      "17",	"2560x1600_50_ParkJoy",
	  );


%seqs = (
	      "CIF30_300_Foreman",         	"-p SourceWidth=352   -p SourceHeight=288   -p FrameRate=30 -p FramesToBeEncoded=16 -p SearchRange=128 -p BiPredMESearchRange=128 -p IntraPeriod=0 ",
		"WQVGA30_RaceHorses",	      "-p SourceWidth=416   -p SourceHeight=240   -p FrameRate=30 -p FramesToBeEncoded=16 -p SearchRange=128 -p BiPredMESearchRange=128 -p IntraPeriod=0 ",
		"WQVGA50_Basketball",	      "-p SourceWidth=416   -p SourceHeight=240   -p FrameRate=50 -p FramesToBeEncoded=16 -p SearchRange=128 -p BiPredMESearchRange=128 -p IntraPeriod=0 ",
		"WQVGA50_PartyScene",	      "-p SourceWidth=416   -p SourceHeight=240   -p FrameRate=50 -p FramesToBeEncoded=7 -p SearchRange=64 -p BiPredMESearchRange=64 -p IntraPeriod=50 ",
		"WQVGA60_BQSquare",	     	"-p SourceWidth=416   -p SourceHeight=240   -p FrameRate=60 -p FramesToBeEncoded=17 -p SearchRange=64 -p BiPredMESearchRange=64 -p IntraPeriod=60 ",

	      "WVGA30_RaceHorses",	     	"-p SourceWidth=832   -p SourceHeight=480   -p FrameRate=30 -p FramesToBeEncoded=300 -p SearchRange=128 -p BiPredMESearchRange=128 -p IntraPeriod=30  ",
	      "WVGA50_Basketball",	      "-p SourceWidth=832   -p SourceHeight=480   -p FrameRate=50 -p FramesToBeEncoded=300 -p SearchRange=128 -p BiPredMESearchRange=128 -p IntraPeriod=50  ",
	      "WVGA50_PartyScene",	  	"-p SourceWidth=832   -p SourceHeight=480   -p FrameRate=50 -p FramesToBeEncoded=300 -p SearchRange=128 -p BiPredMESearchRange=128 -p IntraPeriod=50  ",
	      "WVGA60_BQSquare",	   	"-p SourceWidth=832   -p SourceHeight=480   -p FrameRate=60 -p FramesToBeEncoded=30 -p SearchRange=128 -p BiPredMESearchRange=128 -p IntraPeriod=60  ",

	      "1080p24_ParkScene",	 	"-p SourceWidth=1920  -p SourceHeight=1080  -p FrameRate=24 -p FramesToBeEncoded=240 -p SearchRange=128 -p BiPredMESearchRange=128 -p IntraPeriod=24  ",
	      "1080p50_Basketball",	 	"-p SourceWidth=1920  -p SourceHeight=1080  -p FrameRate=50 -p FramesToBeEncoded=30 -p SearchRange=128 -p BiPredMESearchRange=128 -p IntraPeriod=50  ",
	      "1080p50_Cactus",	 		"-p SourceWidth=1920  -p SourceHeight=1080  -p FrameRate=50 -p FramesToBeEncoded=300 -p SearchRange=128 -p BiPredMESearchRange=128 -p IntraPeriod=50  ",
	      "1080p50_PartyScene",	 	"-p SourceWidth=1920  -p SourceHeight=1080  -p FrameRate=50 -p FramesToBeEncoded=300 -p SearchRange=128 -p BiPredMESearchRange=128 -p IntraPeriod=50  ",
	      "1080p24_Kimono",	 		"-p SourceWidth=1920  -p SourceHeight=1080  -p FrameRate=24 -p FramesToBeEncoded=30 -p SearchRange=128 -p BiPredMESearchRange=128 -p IntraPeriod=50  ",
	      "1080p60_BQSquare",	 	"-p SourceWidth=1920  -p SourceHeight=1080  -p FrameRate=60 -p FramesToBeEncoded=300 -p SearchRange=128 -p BiPredMESearchRange=128 -p IntraPeriod=60  ",

	      "2560x1600_30_PeopleOnStreet",	"-p SourceWidth=2560  -p SourceHeight=1600  -p FrameRate=30 -p FramesToBeEncoded=150 -p SearchRange=128 -p BiPredMESearchRange=128 -p IntraPeriod=30  -p LevelIDC=51 ",
	      "2560x1600_30_Traffic",	 		"-p SourceWidth=2560  -p SourceHeight=1600  -p FrameRate=30 -p FramesToBeEncoded=150 -p SearchRange=128 -p BiPredMESearchRange=128 -p IntraPeriod=30  -p LevelIDC=51 ",
	      "2560x1600_50_ParkJoy",	 		"-p SourceWidth=2560  -p SourceHeight=1600  -p FrameRate=50 -p FramesToBeEncoded=150 -p SearchRange=128 -p BiPredMESearchRange=128 -p IntraPeriod=50  -p LevelIDC=51 ",
	  );



#@qps = ("22","27","32","37"); 
@qps = ("32"); 

#
# Run experiments and restart any aborted job
#

	foreach $seq_num (sort keys %seqsnum) 
	{ 
		$seq_name = $seqsnum{$seq_num};

		foreach $QP (@qps) 
		{

				$p_ParSequence 		= $seqs{$seq_name};			# Sequence-dependent parameters
				$p_InputFile  		= "-p InputFile=\"$seqdir/$seq_name.yuv\"";
				$IQP 				= $QP;
				$PQP 				= $QP+1;
				$BQP 				= $QP+2;

$config_file 	= "encoderIPPP.cfg";

if(1)
{
$exe 	  = "lencod.exe";
$suffix = "xP";

$StartFrame=0;

$FrameSkip=0;
$NumberBFrames=0;
$HierarchicalCoding=0;

$HierB_AdaptiveCadence=1;
$HierP=0;
$HierP_QPoffset=0;
$DisableSmallTransInLargeMB=1;

$RDOQ=1;
$MDDT=1;
$MVC=1;
$HPF=4;
$QALF=1;
$BitDepthLuma=8;
$BitDepthChroma=8;
$MVResolution=1;
$SymbolMode=1;


$p_ParQP 	= "-p QPISlice=$QP -p QPPSlice=$PQP -p QPBSlice=$BQP -p UseRDO_Q=$RDOQ -p UseHPFilter=$HPF -p MVCompetition=$MVC -p UseIntraMDDT=$MDDT -p HierB_AdaptiveCadence=$HierB_AdaptiveCadence -p FrameSkip=$FrameSkip -p NumberBFrames=$NumberBFrames -p HierarchicalCoding=$HierarchicalCoding -p HierP_Level=$HierP -p DisableSmallTransInLargeMB=$DisableSmallTransInLargeMB -p StartFrame=$StartFrame -p UseAdaptiveLoopFilter=$QALF -p HierP_QPoffset=$HierP_QPoffset -p BitDepthLuma=$BitDepthLuma  -p BitDepthChroma=$BitDepthChroma -p MVResolution=$MVResolution -p SymbolMode=$SymbolMode ";

			$output_file = $suffix.".txt";
			print "$seq_name$QP$suffix \n";

			$p_ReconFile  		= "-p ReconFile=\"$suffix.yuv\"";
			$p_OutputFile 		= "-p OutputFile=\"$suffix.264\"";
			$commandline =  "$exe -d $config_file $p_InputFile $p_ReconFile $p_OutputFile $p_ParSequence $p_ParQP > $output_file";
			system($commandline);
			system("del data.txt *.dat");
}

		} # for QP
	} # for seq_name	


#system(pause);


