
/*!
************************************************************************
* \file image.h
*
* \brief
*    prototypes for image.c
*
************************************************************************
*/

#ifndef _IMAGE_H_
#define _IMAGE_H_

#include "mbuffer.h"

#include "global.h"

extern StorablePicture *dec_picture;

void find_snr(struct snr_par *snr, StorablePicture *p, int p_ref);
void get_block(int ref_frame, StorablePicture **list, int x_pos, int y_pos, struct img_par *img, int block[16][16], int , int );
int  picture_order(struct img_par *img);


#ifdef EIGHTH_PEL
void average_block(int block[16][16], int block2[16][16], int, int); 
void average_block4(int block[16][16], int block2[16][16], int block3[16][16], int block4[16][16], int, int); 
void average_block_2(int block[16][16], int block2[16][16], int, int); 
void average_block4_2(int block[16][16], int block2[16][16], int block3[16][16], int block4[16][16], int, int);
#endif



#endif

